package com.css.simulation.resource.scheduler.service;

import api.common.pojo.constants.DictConstants;
import com.css.simulation.resource.scheduler.mapper.ManualProjectMapper;
import com.css.simulation.resource.scheduler.mapper.TaskMapper;
import org.apache.ibatis.session.ExecutorType;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

@Service
public class ManualProjectService {

    @Autowired
    private SqlSessionFactory sqlSessionFactory;
    @Autowired
    ManualProjectMapper manualProjectMapper;
    @Autowired
    TaskMapper taskMapper;

    @Autowired
    StringRedisTemplate stringRedisTemplate;

    public void prepare(String manualProjectTopic,String projectId) {

        //1 redis 设置项目已完成任务为 0
        stringRedisTemplate.opsForValue().set(manualProjectTopic + ":" + projectId + ":taskCompleted", "0");

        try(SqlSession sqlSession = sqlSessionFactory.openSession(ExecutorType.BATCH,false)){
            ManualProjectMapper manualProjectMapper = sqlSession.getMapper(ManualProjectMapper.class);
            TaskMapper taskMapper = sqlSession.getMapper(TaskMapper.class);
            manualProjectMapper.resetProjectState(projectId, DictConstants.PROJECT_RUNNING);   // 修改该 project 的状态为执行中，同时将已完成任务重置为 0 方便测试。
            taskMapper.deleteByProject(projectId); // 将该 project 下所有任务删除。
            sqlSession.commit();
        }
    }

}
