package com.css.simulation.resource.system.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.system.ParameterParam;
import api.common.pojo.po.system.ParameterPO;
import api.common.pojo.vo.system.ParameterVO;
import api.common.util.ObjectUtil;
import com.css.simulation.resource.system.service.ParameterService;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;


@Controller()
@RequestMapping("/parameter")
public class ParameterCtrl {

    @Autowired
    ParameterService parameterService;


    /**
     * 查询参数列表
     */
    @RequestMapping("/getParameterList")
    @ResponseBody
    public ResponseBodyVO<PageInfo<ParameterVO>> getParameterList(@RequestBody ParameterParam pageParam){
        ResponseBodyVO<PageInfo<ParameterVO>> response = new ResponseBodyVO<PageInfo<ParameterVO>>(ResponseBodyVO.Response.SUCCESS);
        response.setInfo(parameterService.getParameterList(pageParam));
        return response;
    }

    /**
     * 新增、修改
     */
    @RequestMapping("/saveParameter")
    @ResponseBody
    public ResponseBodyVO<ParameterPO> saveParameter(@RequestBody ParameterPO parameterPO) throws Exception {
        if(ObjectUtil.isNull(parameterPO)){
            return new ResponseBodyVO(false, 400, "参数必传！",null);
        }
        ResponseBodyVO<ParameterPO> response = new ResponseBodyVO<ParameterPO>(ResponseBodyVO.Response.SUCCESS);
        parameterPO = parameterService.saveParameter(parameterPO);
        response.setInfo(parameterPO);
        return response;
    }

    /**
     * 查询参数修改历史记录
     */
    @RequestMapping("/getParamHistory")
    @ResponseBody
    public ResponseBodyVO<PageInfo<ParameterVO>> getParamHistory(@RequestBody ParameterParam pageParam){
        ResponseBodyVO<PageInfo<ParameterVO>> response = new ResponseBodyVO<PageInfo<ParameterVO>>(ResponseBodyVO.Response.SUCCESS);
        response.setInfo(parameterService.getParamHistory(pageParam));
        return response;
    }


}
