package com.css.simulation.resource.system.service;

import api.common.pojo.param.system.ClusterParam;
import api.common.pojo.po.system.ClusterPO;
import api.common.pojo.vo.system.ClusterVO;
import api.common.util.ObjectUtil;
import api.common.util.StringUtil;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.common.utils.PoUtil;
import com.css.simulation.resource.system.mapper.ClusterMapper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;


@Service
public class ClusterService {

    @Autowired
    ClusterMapper clusterMapper;


    public PageInfo<ClusterVO> getClusterList(ClusterParam clusterParam) {
        PageUtil.setPageInfo(clusterParam);
        List<ClusterVO> list = clusterMapper.getClusterList(clusterParam);
        return new PageInfo<>(list);
    }


    public ClusterPO saveCluster(ClusterPO clusterPO) {
        String id = clusterPO.getId();
        if(ObjectUtil.isNotNull(id)){
            // 更新，将原纪录is_deleted置为1
            ClusterPO deleteClusterPo = new ClusterPO();
            deleteClusterPo.setId(id);
            PoUtil.initDelPo(deleteClusterPo);
            clusterMapper.deleteById(deleteClusterPo);
        }
        clusterPO.setId(StringUtil.getRandomUUID());
        PoUtil.initAddPo(clusterPO);
        clusterMapper.insert(clusterPO);
        return clusterPO;
    }


    public PageInfo<ClusterVO> getClusterHistory(ClusterParam clusterParam) {
        PageUtil.setPageInfo(clusterParam);
        List<ClusterVO> list = clusterMapper.getClusterHistory(clusterParam);
        return new PageInfo<>(list);
    }


    public HashMap<String, Integer> getClusterNum(ClusterParam clusterParam) {

        HashMap<String, Integer> resMap = clusterMapper.getClusterNum(clusterParam);
        return resMap;
    }
}
